/**
 * 
 */
package com.b510.lucene.util;

import java.io.File;
import java.io.IOException;

import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;
import org.apache.lucene.index.CorruptIndexException;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.IndexWriterConfig;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.store.LockObtainFailedException;
import org.apache.lucene.util.Version;

/**
 * @author Hongten <br />
 * @date 2013-1-31
 */
public class LuceneUtil {

	/**
	 * ʼid
	 */
	private String[] ids = { "1", "2", "3", "4", "5", "6" };
	/**
	 * 
	 */
	private String[] emails = { "aa@sina.com", "bb@foxmail.com", "cc@qq.com",
			"dd@163.com", "ee@gmail.com", "ff@sina.com" };
	/**
	 * ʼ
	 */
	private String[] contents = { "hello,aa", "hello,bb", "hello,cc",
			"hello,dd", "hello,ee", "hello,ff" };
	/**
	 * ʼĸ
	 */
	private int[] attachs = { 1, 5, 3, 4, 2, 6 };
	/**
	 * ռ˵
	 */
	private String[] names = { "hongten", "hanyuan", "Devide", "Tom", "Steven",
			"Shala" };

	private Directory directory = null;

	public LuceneUtil() {
		try {
			directory = FSDirectory.open(new File(
					"D:/WordPlace/lucene/lucene_0200_index/lucene/index"));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * 
	 */
	public void index() {
		IndexWriter writer = null;
		try {
			writer = new IndexWriter(directory, new IndexWriterConfig(
					Version.LUCENE_35, new StandardAnalyzer(Version.LUCENE_35)));
			// ĵ
			Document document = null;
			for (int i = 0; i < ids.length; i++) {
				// Field.Store.YES:洢ֵԭʼֵַᱣԴ˿ԽӦĻظַʽ洢
				// Field.Store.NO:洢ֵͨIndex.ANAYLIZEDʹãһЩĵȲҪָĵ
				// ==============================
				// Field.Index.ANALYZED:зִʺڱ⣬ݵ
				// Field.Index.NOT_ANALYZED:ǲзִʣ֤룬IDȣھȷ
				// Field.Index.ANALYZED_NOT_NORMS:зִʣǲд洢normsϢnormsа˴ʱȨֵϢ
				// Field.Index.NOT_ANALYZED_NOT_NORMS:зִҲд洢normsϢ(Ƽ)
				// Field.Index.NO:зִ
				document = new Document();
				document.add(new Field("id", ids[i], Field.Store.YES,
						Field.Index.NOT_ANALYZED_NO_NORMS));
				document.add(new Field("email", emails[i], Field.Store.YES,
						Field.Index.NOT_ANALYZED));
				document.add(new Field("content", contents[i], Field.Store.YES,
						Field.Index.ANALYZED));
				// document.add(new
				// Field("attach",attachs[i],Field.Store.YES,Field.Index.NOT_ANALYZED_NO_NORMS));
				document.add(new Field("name", names[i], Field.Store.YES,
						Field.Index.NOT_ANALYZED_NO_NORMS));
				writer.addDocument(document);
			}
		} catch (CorruptIndexException e) {
			e.printStackTrace();
		} catch (LockObtainFailedException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (writer != null) {
				try {
					writer.close();
				} catch (CorruptIndexException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	/**
	 * ѯ
	 */
	public void query() {
		try {
			IndexReader reader = IndexReader.open(directory);
			System.out.println("ĵĿ" + reader.numDocs());
			System.out.println("ĵ" + reader.maxDoc());
		} catch (CorruptIndexException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
